package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ThingInfo;
import com.izouma.awesomeadmin.service.ThingInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/thingInfo")
public class ThingInfoController {

    @Autowired
    private ThingInfoService thingInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ThingInfo record) {
        List<ThingInfo> pp = thingInfoService.getThingInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getThingInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getThingInfo(@RequestParam(required = false, value = "id") String id) {
        ThingInfo data = thingInfoService.getThingInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ThingInfo record) {
        ThingInfo data = thingInfoService.getThingInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ThingInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<ThingInfo> pp =thingInfoService.getThingInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ThingInfo record) {
        boolean num = thingInfoService.createThingInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateThingInfo(ThingInfo record) {
        boolean num = thingInfoService.updateThingInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteThingInfo(ThingInfo record) {

        boolean num = thingInfoService.deleteThingInfo(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ThingInfo record) throws Exception {

    List<ThingInfo> thingInfos = thingInfoService.getThingInfoList(record);


        String sheetName = "thing_info";
        String titleName = "事物数据表";
        String fileName = "事物表";
        int columnNumber = 25;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "权限" ,   "地标ID" ,   "事物名称" ,   "事物类型" ,   "优先级" ,   "允许导航" ,   "备注" ,   "ICON" ,   "关键字" ,   "图片" ,   "文字描述" ,   "显示距离" ,   "点标模板" ,   "上级ID" ,   "城市ID" ,   "区域ID" ,   "X" ,   "Y" ,   "index"  };
        String[][] dataList = new String[thingInfos.size()][25];

        for (int i = 0; i < thingInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(thingInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(thingInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(thingInfos.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(thingInfos.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(thingInfos.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(thingInfos.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(thingInfos.get(i).getPower());
                        dataList[i][7] = String.valueOf(thingInfos.get(i).getLandmarkId());
                        dataList[i][8] = String.valueOf(thingInfos.get(i).getThingName());
                        dataList[i][9] = String.valueOf(thingInfos.get(i).getThingType());
                        dataList[i][10] = String.valueOf(thingInfos.get(i).getRankLevel());
                        dataList[i][11] = String.valueOf(thingInfos.get(i).getAllowNavigate());
                        dataList[i][12] = String.valueOf(thingInfos.get(i).getRemark());
                        dataList[i][13] = String.valueOf(thingInfos.get(i).getIcon());
                        dataList[i][14] = String.valueOf(thingInfos.get(i).getKeyword());
                        dataList[i][15] = String.valueOf(thingInfos.get(i).getImage());
                        dataList[i][16] = String.valueOf(thingInfos.get(i).getTextIntroduction());
                        dataList[i][17] = String.valueOf(thingInfos.get(i).getShowDistance());
                        dataList[i][18] = String.valueOf(thingInfos.get(i).getTemplateId());
                        dataList[i][19] = String.valueOf(thingInfos.get(i).getFrontLevelId());
                        dataList[i][20] = String.valueOf(thingInfos.get(i).getCityId());
                        dataList[i][21] = String.valueOf(thingInfos.get(i).getAreaId());
                        dataList[i][22] = String.valueOf(thingInfos.get(i).getMapX());
                        dataList[i][23] = String.valueOf(thingInfos.get(i).getMapY());
                        dataList[i][24] = String.valueOf(thingInfos.get(i).getMapIndex());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

